%define _build_pkgcheck_set %{nil}
%define _build_pkgcheck_srpm %{nil}

%global __brp_remove_la_files %nil

%define with_tests 0

%define pkg_name	openldap
%global	beta %{nil}

#defaults
%define build_system 0
%define build_alternatives 0
%define build_modules 1
%define build_modpacks 1
%define build_slp 0
%define build_heimdal 0
%define build_nssov 1
%define build_smbk5pwd 1
%define build_asmmutex 0
%define build_bdb 1
%define build_hdb 1
%global build_migration 0

%if %mgaversion < 9
%define build_system 1
%endif

%{?_with_system: %global build_system 1}
%{?_without_system: %global build_system 0}
%{?_with_modules: %global build_modules 1}
%{?_without_modules: %global build_modules 0}
%{?_with_bdb: %global build_bdb 1}
%{?_without_hdb: %global build_hdb 0}
%{?_with_hdb: %global build_hdb 1}
%{?_without_bdb: %global build_bdb 0}
%{?_with_slp: %global build_slp 1}
%{?_without_slp: %global build_slp 0}
%{?_with_heimdal: %global build_heimdal 1}
%{?_without_heimdal: %global build_heimdal 0}
%{?_with_nssov: %global build_nssov 1}
%{?_without_nssov: %global build_nssov 0}
%{?_with_smbk5pwd: %global build_smbk5pwd 1}
%{?_without_smbk5pwd: %global build_smbk5pwd 0}
%{?_with_asmmutex: %global build_asmmutex 1}
%{?_without_asmmutex: %global build_asmmutex 0}

%define major 		2.4_2
%define fname ldap
%define libname %mklibname %{fname} %{major}
%define migtools_ver 	45

# we want to use the default db version for each release, so as
# to make backport binary compatibles
# excepted for very old systems, where we use bundled db
%define dbutils db5-utils
%define dbutilsprefix db_
%define bundled_db_source_ver 5.3.28
%define dbdevel db-devel

%global db_internal 0
%global lmdb_internal 0
%define dbutils db53-utils
%define dbutilsprefix db53_
%define dbdevel db5-devel
%define dbver 5.3.28

%define dbname %(a=%dbver;echo ${a%.*})
%{?_with_dbinternal: %global db_internal 1}
%{?_without_dbinternal: %global db_internal 0}
%if %{db_internal}
%define dbver %{bundled_db_source_ver}
%endif
%{?_with_lmdbinternal: %global lmdb_internal 1}
%{?_without_lmdbinternal: %global lmdb_internal 0}

%define ol_ver_major 2.4
%if %{build_system}
%define ol_major %{nil}
%define ol_suffix %{nil}
%else
%define ol_major %ol_ver_major
%define ol_suffix 24
%endif

%global _service_status_file /var/lib/ldap%{ol_major}/.service_status_rpm_upgrade

%if %{build_alternatives} || !%{build_system}
%define alternative_major %ol_ver_major
%else
%define alternatives_major %{nil}
%endif

%global clientbin	ldapadd,ldapcompare,ldapdelete,ldapmodify,ldapmodrdn,ldappasswd,ldapsearch,ldapwhoami,ldapexop
%if %{db_internal}
%global serverbin	slapd_db_archive,slapd_db_checkpoint,slapd_db_deadlock,slapd_db_dump,slapd_db_load,slapd_db_printlog,slapd_db_recover,slapd_db_stat,slapd_db_upgrade,slapd_db_verify,slapd-addel,slapd-bind,slapd-modify,slapd-modrdn,slapd-read,slapd-search,slapd-tester,ldif-filter
%else
%global serverbin	slapd-addel,slapd-bind,slapd-modify,slapd-modrdn,slapd-read,slapd-search,slapd-tester,ldif-filter
%endif
%define serversbin	slapadd,slapcat,slapd,slapdn,slapindex,slappasswd,slaptest,slurpd,slapacl,slapauth

#localstatedir is passed directly to configure, and we want it to be /var/lib
#define _localstatedir %%{_var}/run
%define	_libexecdir	%{_sbindir}

# Allow --with[out] SASL at rpm command line build
%{?_without_SASL: %{expand: %%define _without_cyrussasl --without-cyrus-sasl}}
%{?_with_SASL: %{expand: %%define _with_cyrussasl --with-cyrus-sasl}}
%{!?_with_cyrussasl: %{!?_without_cyrussasl: %global _with_cyrussasl --with-cyrus-sasl}}
%{?_with_cyrussasl: %define _with_cyrussasl --with-cyrus-sasl}
%{?_without_cyrussasl: %define _without_cyrussasl --without-cyrus-sasl}
%{?_with_gdbm: %global db_conv dbb}
%{!?_with_gdbm: %global db_conv gdbm}
%global build_sql 1
%{?_without_sql: %global build_sql 0}
%global back_perl 0
%global back_shell 0

%global build_modp_mdb 1
%global lmbd_internal 0
%global build_modp_ldap 0
%global build_modp_passwd 0
%global build_modp_dnssrv 0
%global build_modp_sql 1
%global build_modp_bdb 0
%global build_modp_hdb 0

%if %{build_modpacks}
  %if %{build_sql}
    %global build_modp_sql 1
  %endif
  %if %{build_bdb}
    %global build_modp_bdb 1
  %endif
  %if %{build_hdb}
    %global build_modp_hdb 1
  %endif
%endif

Summary: 	LDAP servers and sample clients
Name: 		%{pkg_name}%{ol_major}
Version: 	2.4.59
Release:	%mkrel 6
License: 	OpenLDAP
Group: 		System/Servers
URL: 		https://www.openldap.org/

# Openldap source
Source0: 	https://www.openldap.org/software/download//OpenLDAP/openldap-release/%{pkg_name}-%{version}%{beta}.tgz

Source13:	README-openldap2.4.mdv

# Specific source
Source2: 	%{pkg_name}.sysconfig
Source3:	slapd.service
Source4:	ldap-config
Source19:	gencert.sh
Source20:	ldap.logrotate
Source21:	slapd.conf
Source22:	DB_CONFIG
Source23:	ldap.conf
Source24:	slapd.access.conf
Source25:	ldap-hot-db-backup
Source26:	ldap-reinitialise-slave
Source27:	ldap-common

# Migration tools
Source11:	https://www.padl.com/download/MigrationTools-%{migtools_ver}.tar.bz2
Source14: 	migration-tools.txt
Source15: 	migrate_automount.pl

Source30:	http://www.sleepycat.com/update/snapshot/db-%{bundled_db_source_ver}.tar.gz

# Extended Schema 
Source54: 	mull.schema

# Doc sources, used to patch docs and also generate SOURCE13 above
Source100:	openldap-2.4-admin-guide-add-vendor-doc.patch
Source101:	vendor.sdf
Source102:	vendor-standalone.sdf

# Chris Patches
Patch0: 	%{pkg_name}-2.3.4-config.patch
Patch1:		%{pkg_name}-2.0.7-module.patch

#Fix various paths in smbk5pwd:
Patch2:		openldap-2.4-smbk5passwd-paths.patch
# For now, only build support for SMB (no krb5) changing support in smbk5passwd
# overlay:
Patch3:		openldap-2.4-smbk5passwd-only-smb.patch
Patch4:		openldap-2.4.25-contrib-makefiles-with-tests.patch
Patch5:		openldap-2.4.8-fix-lib-perms.patch
Patch6:		openldap-2.4.12-test001-check-slapcat.patch
Patch7:		openldap-2.4.33-slapi-module.patch
Patch8:		openldap-2.4.33-slapi-exop.patch
Patch9:		openldap-2.4-lmdb-shared.patch

# RH + PLD Patches
Patch15:	%{pkg_name}-cldap.patch

# Migration tools Patch
Patch40: 	MigrationTools-34-instdir.patch
Patch41: 	MigrationTools-36-mktemp.patch
Patch42: 	MigrationTools-27-simple.patch
Patch43: 	MigrationTools-26-suffix.patch
Patch45:	MigrationTools-45-i18n.patch
# schema patch
Patch46: 	openldap-2.0.21-schema.patch
Patch47: 	openldap-2.4.12-change-dyngroup-schema.patch
# http://qa.mandriva.com/show_bug.cgi?id=15499
Patch48:	MigrationTools-45-structural.patch

%if %{build_modp_mdb} && ! %{lmdb_internal}
BuildRequires:	lmdb-devel >= 0.9.24
%endif

%if %{build_bdb} || %{build_hdb}
# Upstream bdb patches

# https://www.oracle.com/technology/software/products/berkeley-db/db/
%if %{db_internal}
# used by s_config, which is required by above patch:
BuildRequires:	ed autoconf
%else
# txn_nolog added in 4.2.52-6mdk
BuildRequires:	%{dbdevel} >= %{dbver}
%endif
%endif

Patch53:	%{pkg_name}-ntlm.patch
# preserves the temp file used to import data if an error occured
Patch54:	MigrationTools-40-preserveldif.patch

#
# Security patches
# patches 1000 -> ...
#
Patch100: 0001-ITS-9815-slapd-sql-escape-filter-values.patch


#patches in CVS
# see https://www.stanford.edu/services/directory/openldap/configuration/openldap-build.html
# for other possibly interesting patches


%{?_with_cyrussasl:BuildRequires: 	libsasl-devel}
%{?_with_kerberos:BuildRequires:	krb5-devel}
BuildRequires:	openssl-devel
BuildRequires:	perl
%if %{build_slp}
BuildRequires:	openslp-devel
%endif
%if %{build_heimdal}
BuildRequires:	heimdal-devel
%endif
%if %{build_sql}
BuildRequires:	unixODBC-devel
%endif
%if %{back_perl}
BuildRequires:	perl-devel
%endif
BuildRequires:	ncurses-devel >= 5.0
BuildRequires:	libtool-devel
BuildRequires:	krb5-devel
BuildRequires:	groff
BuildRequires:	sdf
BuildRequires:  chrpath
# for make test:
BuildRequires:	diffutils
Requires:	shadow-utils, setup >= 2.2.0-6mdk
#Requires:	openldap-back_bdb 

%description
OpenLDAP is an open source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools.  The suite includes a
stand-alone LDAP server (slapd) which is in the -servers package, libraries for
implementing the LDAP protocol (in the lib packages), and utilities, tools, and
sample clients (in the -clients package). The openldap binary package includes
only configuration files used by the libraries.

Install openldap if you need LDAP applications and tools.

%package servers
Summary: 	OpenLDAP servers and related files
Group: 		System/Servers
# mdb is now the default backend in the default config, so require it:
%if %{build_modp_mdb}
Requires:	%{name}-back_mdb = %{version}
%endif
Requires(post):	systemd >= %{systemd_required_version}
Requires(pre):	rpm-helper >= 0.23 coreutils
BuildRequires:	rpm-helper >= 0.23
%if !%{build_modpacks}
Provides:	%{name}-back_dnssrv = %{version}-%{release}
Provides:	%{name}-back_ldap = %{version}-%{release}
Provides:	%{name}-back_passwd = %{version}-%{release}
%endif
%if %{build_sql} && !%{build_modp_sql}
Provides:	%{name}-back_sql = %{version}-%{release}
%endif
%if %{?_with_cyrussasl:1}%{!?_with_cyrussasl:0}
%define saslver %([ -f "%{_includedir}/sasl/sasl.h" ] && echo -e "#include <sasl/sasl.h>\\nSASL_VERSION_MAJOR SASL_VERSION_MINOR SASL_VERSION_STEP"|cpp|awk 'END {printf "%s.%s.%s",$1,$2,$3}' || echo "2.1.22")
%define sasllib %mklibname sasl 2 3
#Ensure we have the sasl library we compiled against available in post so
#slapadd etc works
Requires(post):	%{sasllib} = %{saslver}
%endif
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{pkg_name}%{ol_major}-extra-schemas >= 1.3-7
Requires(pre): 	%{pkg_name}%{ol_major}-extra-schemas >= 1.3-7
# file /usr/lib64/libslapi-2.4.so.2.11.7 conflicts between attempted installs of 
# openldap2.4-servers-2.4.59-4.mga8.x86_64 and openldap-servers-2.4.59-4.mga8.x86_64
%if !%build_system
Conflicts: openldap-servers < 2.5
%endif

%description servers
OpenLDAP Servers

This package contains the OpenLDAP server, slapd (LDAP server), additional 
backends, configuration files, schema definitions required for operation, and 
database maintenance tools

%if !%{build_modpacks}
The following local storage backends are supplied in this package:
%endif
%if !%{build_modp_mdb}
-mdb
%endif
%if !%{build_modp_bdb}
-bdb
-hdb
%endif

%package servers-devel
Summary:	OpenLDAP SLAPI development libraries and header files
Group: 		Development/C
Requires: 	%{name}-servers = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Provides:	%{name}-servers-devel = %{version}-%{release}

%description servers-devel
This package includes the development libraries and header files
needed for compiling OpenLDAP server plugins that use SLAPI. Install
this package only if you plan to develop or will need to compile
OpenLDAP server plugins.

%package clients
Summary: 	OpenLDAP clients and related files
Group: 		System/Servers
Requires: 	%libname = %{version}-%{release}

%description clients
OpenLDAP clients

This package contains command-line ldap clients (ldapsearch, ldapadd etc)

%if %{build_migration}
%package migration
Summary: 	Set of scripts for migration of a nis domain to a ldap directory
Group: 		System/Configuration/Other
Requires: 	%{name}-servers = %{version}
Requires: 	%{name}-clients = %{version}

%description migration
This package contains a set of scripts for migrating data from local files
(ie /etc/passwd) or a nis domain to an ldap directory.
%endif

%package -n %{libname}
Summary: 	OpenLDAP libraries
Group: 		System/Libraries
Provides:       lib%{fname} = %{version}-%{release}
# This is needed so all libldap2 applications get /etc/openldap/ldap.conf
# which was moved from openldap-clients to openldap in 2.1.25-4mdk
Requires:	%{pkg_name} >= 2.1.25-4mdk

%description -n %{libname}
This package includes the libraries needed by ldap applications.


%package -n %{libname}-devel
Summary: 	OpenLDAP development libraries and header files
Group: 		Development/C
Requires: 	%{libname} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
%if %{build_system}
Provides: 	lib%{fname}-devel = %{version}-%{release}
Provides:	openldap2-devel = %{version}-%{release}
%endif

%description -n %{libname}-devel
This package includes the development libraries and header files
needed for compiling applications that use LDAP internals.  Install
this package only if you plan to develop or will need to compile
LDAP clients.


%package -n %{libname}-static-devel
Summary: 	OpenLDAP development static libraries
Group: 		Development/C
Requires: 	%{libname}-devel = %{version}-%{release}
%if %{build_system}
Provides: 	lib%{fname}-devel-static = %{version}-%{release}
Provides: 	lib%{fname}-static-devel = %{version}-%{release}
Provides:	openldap-devel-static = %{version}-%{release}
Provides:	openldap-static-devel = %{version}-%{release}
%endif


%description -n %{libname}-static-devel
OpenLDAP development static libraries

%if %{build_modpacks}
%if 0
%package back_dnssrv
Summary: 	Module dnssrv for OpenLDAP 
Group: 		System/Libraries
Requires: 	%libname = %{version}-%{release}
Requires: 	%{name}-servers = %{version}-%{release}

%description back_dnssrv
The dnssrv daabase backend module for OpenLDAP daemon

%package back_ldap
Summary: 	Module ldap for OpenLDAP 
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-servers = %{version}-%{release}

%description back_ldap
The ldap database backend module for OpenLDAP daemon

%package back_passwd
Summary: 	Module passwd for OpenLDAP 
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-servers = %{version}-%{release}

%description back_passwd
The passwd database backend module for OpenLDAP daemon
%endif

%if %{build_modp_sql}
%package back_sql
Summary: 	Module sql for OpenLDAP 
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-servers = %{version}-%{release}

%description back_sql
The sql database backend module for OpenLDAP daemon
%endif

%if %{build_modp_bdb}
%package back_bdb
Summary: 	Berkeley DB backends for OpenLDAP server
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-servers = %{version}-%{release}
%if !%{db_internal}
Requires(pre):	%{dbutils}
Requires(post):	%{dbutils}
# slapd checks at startup if the library version matches exactly what it
# was compiled against, so we cant allow newer versions, e.g.:
#bdb_back_initialize: BDB library version mismatch: expected Berkeley DB 4.8.26: (December 30, 2009), got Berkeley DB 4.8.30: (March 25, 2011)
# This might need to be changed to a library dependency, but we need to verify
# library provides on multiple distros before doing that
Requires:	%{dbutils} = %{dbver}
%endif

%description back_bdb
This package contains the Berkeley DB-based backends for the OpenLDAP
LDAP server:
-bdb
-hdb

The bdb backend is now (in 2.4) deprecated, and the hdb backend will be
deprecated in 2.5.  Both bdb and hdb will be removed in 2.6. Users are
encouraged to migrate to the mdb backend.

%if %{db_internal}
This package also includes an internal copy of Berkely DB %{bundled_db_source_ver}
%endif
%endif
%endif

%if %{build_modp_mdb}
%package back_mdb
Summary: 	Lightning Memory-Mapped Database backend for OpenLDAP server
Group: 		System/Libraries
Requires: 	%{libname} = %{version}-%{release}
Requires: 	%{name}-servers = %{version}-%{release}
%if !%{lmdb_internal}
Requires:       lmdb
#OpenLDAP checks the version number it was compiled against, and aborts
#if it differs
Requires:	%{_lib}lmdb0 == %(rpm -q --whatprovides lmdb-devel  --qf '%%{version}')
#Requires
%endif

%description back_mdb
This package contains the Lightning Memory-Mapped Database backend for
OpenLDAP, using the lmdb (Lightning Memory-Mapped Database) database library
developed specifically for OpenLDAP
%endif

%package doc
Summary: 	OpenLDAP documentation and administration guide
Group: 		Documentation
Requires: 	openldap
Provides:	openldap-guide

%description doc
OpenLDAP documentation, including RFCs and the administration guide

%package tests
Summary:	OpenLDAP Test Suite - tests and data
Group:		Development/Other
Requires:	%{name}-servers %{name}-clients %{name}-testprogs
%if %{build_modp_bdb}
Recommends:   %{name}-back_bdb = %{version}-%{release}
%endif
%if %{build_modp_hdb}
Recommends:   %{name}-back_hdb = %{version}-%{release}
%endif
%if %{build_modp_mdb}
Recommends:	%{name}-back_mdb = %{version}-%{release}
%endif

%description tests
OpenLDAP now has a substantial test suite, which includes sample configurations
and data for a large number of scenarios and features. These are useful for
testing the installed server, and seeing examples of how to use the features.

The intention is that it should be possible to run the entire test suite on
the installed server using this package.

To run the tests, use e.g.:
$ make -C /usr/share/openldap/tests test-mdb

To run the tests for all back-ends (after installing all recommended packages),
use: 
$ make -C /usr/share/openldap/tests test

%package testprogs
Summary:	OpenLDAP Test Suite - simple testing client binaries
Group:		Development/Other

%description testprogs
Programs shipped with the test suite which are used by the test suite, and may
also be useful as load generators etc.

%prep
%setup -q -n %{pkg_name}-%{version}%{beta} %{?_with_migration:-a 11} %{?_with_bdb:-a 30}

#build the docs
pushd doc/guide/admin
patch -p0 < %{SOURCE100}
cp %{SOURCE101} %{SOURCE102} .
make
sdf -2txt_ vendor-standalone.sdf
cp vendor-standalone.txt %{SOURCE13}
popd

%if %{build_bdb} || %{build_hdb}
%if %{db_internal}
pushd db-%{dbver} >/dev/null

# upstream bdb patches

#(cd dist && ./s_config)
popd >/dev/null
%endif
%endif # build_bdb || build_hdb

%patch0 -p1 -b .config
perl -pi -e 's/LDAP_DIRSEP "run" //g' include/ldap_defaults.h
%patch1 -p1 -b .module
%patch2 -p1 -b .smbk5paths
%if !%{build_heimdal}
%patch3 -p1 -b .smbonly
%endif
#patch4 -p1 -b .contribmake
%patch7 -p1 -b .slapi-module
%patch8 -p1 -b .slapi-exop
%if ! %{lmdb_internal}
%patch9 -p1 -b .liblmdbshared
%endif
%patch15 -p1 -b .cldap 

%patch100 -p1

%if %{build_migration}
pushd MigrationTools-%{migtools_ver}
%patch40 -p1 -b .instdir
%patch41 -p1 -b .mktemp
%patch42 -p1 -b .simple
%patch43 -p1 -b .suffix
%patch45 -p2 -b .i18n
%patch48 -p2 -b .account
%patch54 -p1 -b .preserve
popd
%endif

%patch46 -p1 -b .mdk
%patch47 -p1 -b .dyngroup
#bgmilne %patch47 -p1 -b .maildropschema
# FIXME
%patch53 -p1 -b .ntlm

# patches from CVS
perl -pi -e 's/testrun/\${TESTDIR}/g' tests/scripts/test024-unique

# README:
cp %{SOURCE13} README.mageia

# test049 not ready for not writing to testdir ...
mv tests/scripts/{,broken}test049*

%patch5 -p1
%patch6 -p1
chmod a+rx tests/scripts/test054*

# The change is needed for autoconf-2.71
sed 's@^AM_INIT_AUTOMAKE.*@AC_PROG_MAKE_SET@' -i configure.in

%build
autoreconf -fi
%serverbuild

%if %{build_bdb} || %{build_hdb}
%if %{db_internal}
dbdir=`pwd`/db-instroot
pushd db-%{dbver}/build_unix
CONFIGURE_TOP="../dist" %configure \
        --enable-shared --disable-static \
        --with-uniquename=_openldap_slapd%{ol_suffix}_mdv \
	--program-prefix=slapd%{ol_major}_ \
%if %{build_asmmutex}
%ifarch %{ix86}
	--disable-posixmutexes --with-mutex=x86/gcc-assembly
%endif
%ifarch x86_64
	--disable-posixmutexes --with-mutex=x86_64/gcc-assembly
%endif
%else
	--with-mutex=POSIX/pthreads/library
%endif

#--with-mutex=POSIX/pthreads/library
#JMD: use --disable-posixmutexes so it works on a non-NPTL kernel, and use
#assembler mutexes since they're *way* faster and correctly implemented.

perl -pi -e 's/^(libdb_base=\s+)\w+/\1libslapd%{ol_suffix}_db/g' Makefile
#Fix soname and libname in libtool:
#perl -pi -e 's/shared_ext/shrext/g' libtool
make
rm -Rf $dbdir
mkdir -p $dbdir
make DESTDIR=$dbdir install
ln -sf ${dbdir}%{_libdir}/libslapd%{ol_suffix}_db-%{dbname}.so ${dbdir}/%{_libdir}/libdb-%{dbname}.so
chmod u+w ${dbdir}/usr/include/db.h
grep __lock_ db_int_def.h >> ${dbdir}/usr/include/db.h
popd
export CPPFLAGS="-I${dbdir}%{_includedir} $CPPFLAGS"
#export LDFLAGS="-L${dbdir}/%{_libdir} $LDFLAGS"
#default LDFLAGS will be added, and having some options twice breaks build
export LDFLAGS="-L${dbdir}%{_libdir}"
export LD_LIBRARY_PATH="${dbdir}%{_libdir}"
%endif
%endif # build_bdb || build_hdb

unset CONFIGURE_TOP

# Either build the internal lmdb and compile against it, or remove it
%if %{lmdb_internal}
make -C libraries/liblmdb
%else
rm -Rf libraries/liblmdb
export MDB_LIBS=-llmdb
%endif

#FIXME: Some script backends should not be used with threads, mostly shell/perl

%if !%{build_system}
perl -pi -e 's,(progname = "\w+)",${1}%{ol_major}",g' servers/slapd/*.c
perl -pi -e 's,({"slap\w+)",${1}%{ol_major}",g' servers/slapd/main.c
%endif

# don't choose db4.3 even if it is available
export ol_cv_db_db_4_dot_3=no
# try and miss linuxthreads, so we get a threading lib on glibc2.4:
export ol_cv_header_linux_threads=no
#rh only:
export CPPFLAGS="-I%{_prefix}/kerberos/include $CPPFLAGS"
export LDFLAGS="-L%{_prefix}/kerberos/%{_lib} $LDFLAGS"
%if %{?openldap_fd_setsize:1}%{!?openldap_fd_setsize:0}
CPPFLAGS="$CPPFLAGS -DOPENLDAP_FD_SETSIZE=%{openldap_fd_setsize}"
%endif
# FIXME glibc 2.8 breakage, this is not the correct fix, see
# https://www.openldap.org/its/index.cgi/Build?id=5464;selectid=5464
CPPFLAGS="$CPPFLAGS -D_GNU_SOURCE"
# building for systems with kernel < 2.6 requires building without epoll support
%if 0%{?_without_epoll:1}
export ac_cv_header_sys_epoll_h=no
%endif

%configure \
	--with-subdir=%{name} \
%if !%{build_system}
	--program-suffix=%{ol_major} \
%endif
	--localstatedir=%{_var}/run/ldap%{ol_major} \
	--enable-dynamic \
	--enable-syslog \
	--enable-proctitle \
	--enable-ipv6 \
	--enable-local \
	%{?_with_cyrussasl} %{?_without_cyrussasl} \
	%{?_with_kerberos} %{?_without_kerberos} \
	--with-threads \
	--with-tls \
	--enable-slapd \
	--enable-dynacl \
	--enable-aci \
	--enable-cleartext \
	--enable-crypt \
	--enable-lmpasswd \
	%{?_with_kerberos:--enable-kpasswd} \
	%{?_with_cyrussasl:--enable-spasswd} \
%if %{build_modules}
	--enable-modules \
%endif
	--enable-rewrite \
	--enable-rlookups \
%if %{build_slp}
	--enable-slp \
%endif
	--disable-wrappers \
%if %{build_bdb}
	--enable-bdb=mod \
%else
	--enable-bdb=no \
%endif
%if %{build_hdb}
	--enable-hdb=mod \
%else
	--enable-hdb=no \
%endif
	--enable-ndb=no \
	--enable-backends=mod \
%if %{back_perl}
	--enable-perl=mod \
%else
	--enable-perl=no \
%endif
%if !%{back_shell}
	--enable-shell=no \
%endif
%if %{build_sql}
	--enable-sql=mod \
%else
	--enable-sql=no \
%endif
	--enable-overlays=mod \
	--enable-shared \
	--enable-slapi

%if !%{build_system}
perl -pi -e 's/^(ldap_subdir\s+=\s+.*)%{pkg_name}/$1%{name}/g' Makefile
perl -p -i.bak -e 's/slapd-(search|read|addel|modrdn|modify|bind)/slapd-${1}%{ol_major}/g' tests/progs/slapd-tester.c
%endif

# (oe) amd64 fix
perl -pi -e "s|^AC_CFLAGS.*|AC_CFLAGS = $CFLAGS -fPIC|g" libraries/librewrite/Makefile

make depend 

make 
export LIBTOOL=`pwd`/libtool

if [ -d /usr/kerberos/%{_lib} ]; then export LIBRARY_PATH=/usr/kerberos/%{_lib}; fi
perl -p -i.noradius -e 's/pw-radius.la//g' contrib/slapd-modules/passwd/Makefile
#acl broken
for i in addpartial allop allowed autogroup cloak denyop dsaschema dupent kinit \
    lastbind lastmod noopsrch \
%if %{build_nssov}
    nssov \
%endif
%if %{build_smbk5pwd}
    smbk5pwd \
%endif
    passwd passwd/sha2 passwd/pbkdf2 trace
do
    make -C contrib/slapd-modules/$i libdir=%{_libdir} moduledir=%{_libdir}/%{name}
done

%check
%if %{!?_with_test:0}%{?_with_test:1}
%if !%{build_system}
pushd clients/tools
for OLD in {%{clientbin}}
do
    NEW=`echo ${OLD}%{alternative_major}`
    ln -sf $OLD $NEW
    #mv -f $OLD $NEW ||:
    #if [ -L $NEW ]
    #then ln -sf `readlink $NEW`%{alternative_major} $NEW
    #fi
done
popd
%endif
#disable icecream:
#PATH=`echo $PATH|perl -pe 's,:[\/\w]+icecream[\/\w]+:,:,g'`
%if %{build_bdb} || %{build_hdb}
%if %{db_internal}
dbdir=`pwd`/db-instroot
export LD_LIBRARY_PATH="${dbdir}%{_libdir}"
%endif
# meta test seems to timeout on the Mandriva cluster:
#export TEST_META=no
# Use a pseudo-random number between 9000 and 10000 as base port for slapd in tests
export SLAPD_BASEPORT=$[9000+RANDOM%1000]
make -C tests %{!?tests:test}%{?tests:%tests}
%endif # build_bdb || build_hdb
%endif # with_test

%install
#disable icecream:
#PATH=`echo $PATH|perl -pe 's,:[\/\w]+icecream[\/\w]+:,:,g'`
export DONT_GPRINTIFY=1
export DONT_REMOVE_LIBTOOL_FILES=1
for i in addpartial allop allowed autogroup kinit \
%if %{build_nssov}
    nssov \
%endif
%if %{build_smbk5pwd}
    smbk5pwd \
%endif
    passwd 
do
cp -af contrib/slapd-modules/$i/README{,.$i}
done
cp contrib/slapd-modules/passwd/sha2/README{,.sha2}
cp contrib/slapd-modules/passwd/pbkdf2/README{,.pbkdf2}
rm -Rf %{buildroot}

%if %{build_bdb} || %{build_hdb}
%if %{db_internal}
pushd db-%{dbver}/build_unix
%make_install STRIP="/bin/true"
# bash bug? globs not expanding with -e
set +e
for i in %{buildroot}/%{_bindir}/db_*;do mv $i ${i/db_/slapd_db_};done
set -e
popd
# For contrib tests
export LD_LIBRARY_PATH=%{buildroot}/%{_libdir}
%endif
%endif

%make_install STRIP="" 
%if %{lmdb_internal}
# If we build the internal copy, we want the utlities, but not the development files 
# which will conflict with liblmdb-devel. All binaries are statically linked at 
# present, so no shared library required.
mkdir -p %{buildroot}/%{_prefix}/lib %{buildroot}/%{_prefix}/man/man1
make -C libraries/liblmdb install STRIP="" DESTDIR=%{buildroot} prefix=%{_prefix}
if [ "%{_prefix}/lib" != "%{_libdir}" ]
    then mv %{buildroot}/%{_prefix}/lib/* %{buildroot}/%{_libdir}
    rmdir %{buildroot}/%{_prefix}/lib
fi
mv %{buildroot}/%{_prefix}/man/man1/* %{buildroot}/%{_mandir}/man1
rmdir %{buildroot}/%{_prefix}/man/man1
rm -f %{buildroot}/%{_includedir}/lmdb.h %{buildroot}/%{_libdir}/liblmdb.so
%endif

%if %{build_smbk5pwd}
cp -a contrib/slapd-modules/smbk5pwd/.libs/smbk5pwd.so* %{buildroot}/%{_libdir}/%{name}
%if !%{build_heimdal}
for i in %{buildroot}/%{_libdir}/%{name}/smbk5pwd*
do 
  if [ -L ${i} ]
  then
    newlink=`readlink $i|sed -e 's/k5//g'`
    rm $i
    ln -svf $newlink ${i/k5/}
  else
    mv $i ${i/k5/}
  fi
done
%endif
%endif

cp contrib/slapd-modules/allop/slapo-allop.5 %{buildroot}/%{_mandir}/man5
cp contrib/slapd-modules/cloak/slapo-cloak.5 %{buildroot}/%{_mandir}/man5
cp contrib/slapd-modules/lastbind/slapo-lastbind.5 %{buildroot}/%{_mandir}/man5
cp contrib/slapd-modules/lastmod/slapo-lastmod.5 %{buildroot}/%{_mandir}/man5

#cp contrib/slapd-modules/*/*.so %{buildroot}/%{_libdir}/%{name}

#smbk5pwd skipped, installed as smbpwd above
#dsaschema broken on 32bit
for i in addpartial allop allowed autogroup cloak denyop dupent kinit \
    lastbind lastmod noopsrch \
%if %{build_nssov}
    nssov \
%endif
    passwd passwd/sha2 passwd/pbkdf2 trace
do 
    #if make -C contrib/slapd-modules/$i test
    #then 
      make DESTDIR=%{buildroot} mandir=%{_mandir} moduledir=%{_libdir}/%{name} schemadir=%{_sysconfdir}/%{name}/schema -C contrib/slapd-modules/$i install
    rm -f %{buildroot}/%{_libdir}/%{name}/$i.a
    #else exit 1
    #fi
done
rm -f %{buildroot}/%{_libdir}/%{name}/kerberos.a
rm -f %{buildroot}/%{_libdir}/%{name}/netscape.a
rm -f %{buildroot}/%{_libdir}/%{name}/sha2.a
rm -f %{buildroot}/%{_libdir}/%{name}/pbkdf2.a
#compat symlinks, DONT REMOVE
ln -s pw-netscape.so %{buildroot}/%{_libdir}/%{name}/netscape.so
ln -s pw-netscape.la %{buildroot}/%{_libdir}/%{name}/netscape.la
ln -s pw-kerberos.so %{buildroot}/%{_libdir}/%{name}/kerberos.so
ln -s pw-kerberos.la %{buildroot}/%{_libdir}/%{name}/kerberos.la
    
# We already had ldapns.schema in extra-schemas
rm -f %{buildroot}/%{_sysconfdir}/%{name}/schema/ldapns.schema

# SLAPI static library seems to make no sense
rm -f %{buildroot}/%{_libdir}/libslapi.a

# try and ship the tests such that they will run properly

install -d %{buildroot}/%{_datadir}/%{name}/tests
cp -a tests/{data,scripts,Makefile,run} %{buildroot}/%{_datadir}/%{name}/tests
ln -s %{_datadir}/%{name}/schema %{buildroot}/%{_datadir}/%{name}/tests
find %{buildroot}/%{_datadir}/%{name}/tests -type f -name '*.conf' -exec perl -pi -e 's,\.\.\/servers\/slapd\/back-.*,%{_libdir}/%{name},g;s,\.\.\/servers\/slapd\/overlays,%{_libdir}/%{name},g' {} \;
perl -pi -e 's,(\`pwd\`\/)?\.\.\/servers\/(slapd|slurpd)\/(slapd|slurpd),%{_sbindir}/${2}%{ol_major},g;s,^PROGDIR=.*,PROGDIR=%{_bindir},g;s,^CLIENTDIR=.*,CLIENTDIR=%{_bindir},g;s,^TESTDIR=.*,TESTDIR=\${USER_TESTDIR-\$TMPDIR/openldap-testrun},g;s/ldap(search|add|delete|modify|whoami|compare|passwd|modrdn|exop)/ldap${1}%{ol_major}/g;s/slapd-tester$/slapd-tester%{ol_major}/g;s,\$TESTWD\/,,g;s/^(\.\*.*)\$(.*)/${1}\`pwd\`\/\$${2}/g' %{buildroot}/%{_datadir}/%{name}/tests/scripts/defines.sh %{buildroot}/%{_datadir}/%{name}/tests/run
perl -pi -e 's/testrun/\$TESTDIR/g;s,^SHTOOL=.*,. scripts/defines.sh,g' %{buildroot}/%{_datadir}/%{name}/tests/scripts/all
perl -p -i.bak -e 's,^olcModulePath: .*,olcModulePath: %{_libdir}/%{name},g' %{buildroot}/%{_datadir}/%{name}/tests/scripts/test*
perl -pi -e 's/^(Makefile|SUBDIRS)/#$1/g' %{buildroot}/%{_datadir}/%{name}/tests/Makefile
echo 'SHTOOL="./scripts/shtool"' >> %{buildroot}/%{_datadir}/%{name}/tests/scripts/defines.sh
install -m755 build/shtool %{buildroot}/%{_datadir}/%{name}/tests/scripts
if [ -n "%{ol_major}" ]
then for i in addel bind modify modrdn read search tester
do ln -sf slapd-${i} tests/progs/slapd-${i}%{ol_major}
done
fi
ln -s %{_datadir}/%{name}/tests/data %{buildroot}/%{_datadir}/%{name}/tests/testdata

install -m755 tests/progs/.libs/slapd-* tests/progs/.libs/ldif-filter %{buildroot}/%{_bindir}

### some hack
perl -pi -e "s| -L../liblber/.libs||g" %{buildroot}%{_libdir}/libldap.la

perl -pi -e  "s,-L$RPM_BUILD_DIR\S+%{_libdir},,g" %{buildroot}/%{_libdir}/lib*.la
#sed -i -e "s|-L$RPM_BUILD_DIR/%{name}-%{version}/db-instroot/%{_libdir}||g" %{buildroot}/%{_libdir}/*la
#%{buildroot}/%{_libdir}/%{name}/*.la 

### Init scripts
install -d %{buildroot}%{_unitdir}
install -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/slapd%{ol_major}.service

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/slapd%{ol_major}

install -m 640 %{SOURCE21} %{SOURCE23} %{SOURCE24} %{buildroot}%{_sysconfdir}/%{name}
install -d %{buildroot}/%{_sysconfdir}/%{name}/slapd.d
# People have claimed that:
# slapd.conf(5) is obsoleted since 2.3, see slapd-config(5)
# But, if this was the case, surely, slapd-config(5) or slapd.conf(5)
# would support that claim. Yes, slapd.conf is deprecated, and slapd-config
# has some nice features (and all you need to do to migrate to it is run
# /usr/share/openldap/scripts/ldap-config convert), but we are not switching
# to it by default until slapd-modify is provided (which seemingly will
# only be in 2.5).
#install -m640 -o ldap -g ldap -d /etc/openldap/slapd.d

### repository dir
install -d %{buildroot}%{_var}/lib/ldap%{ol_major}

### DB_CONFIG for bdb backend
%if %{build_bdb} || %{build_hdb}
install -m644 %{SOURCE22} %{buildroot}%{_var}/lib/ldap%{ol_major}
mv %{buildroot}%{_var}/run/ldap%{ol_major}/openldap-data/DB_CONFIG.example %{buildroot}/%{_var}/lib/ldap%{ol_major}/
%endif

### run dir
install -d %{buildroot}%{_tmpfilesdir}
cat >%{buildroot}%{_tmpfilesdir}/%{pkg_name}%{ol_major}.conf <<EOF
d /run/ldap%{ol_major} 0755 ldap ldap
EOF

### Server defaults
echo "localhost" > %{buildroot}%{_sysconfdir}/%{name}/ldapserver

### we don't need the default files 
rm -f %{buildroot}/etc/%{name}/*.default 
rm -f %{buildroot}/etc/%{name}/schema/*.default 


### Standard schemas should not be changed by users
install -d %{buildroot}%{_datadir}/%{name}/schema
mv -f %{buildroot}%{_sysconfdir}/%{name}/schema/* %{buildroot}%{_datadir}/%{name}/schema/

### install additional schemas
install -m 644 %{SOURCE54} %{buildroot}%{_datadir}/%{name}/schema/

install -d %{buildroot}/%{_datadir}/%{name}/scripts
install -m 755 %{SOURCE4} %{SOURCE25} %{SOURCE26} %{SOURCE27} %{buildroot}/%{_datadir}/%{name}/scripts/
for i in hourly daily weekly monthly yearly
do
	install -d %{buildroot}/%{_sysconfdir}/cron.${i}
	ln -s %{_datadir}/%{name}/scripts/ldap-hot-db-backup %{buildroot}/%{_sysconfdir}/cron.${i}/ldap-hot-db-backup%{ol_major}
done
perl -pi -e 's,%{_bindir}/db_,%{_bindir}/%{dbutilsprefix},g' %{buildroot}/%{_datadir}/%{name}/scripts/ldap-common

### create local.schema
echo "# This is a good place to put your schema definitions " > %{buildroot}%{_sysconfdir}/%{name}/schema/local.schema
chmod 644 %{buildroot}%{_sysconfdir}/%{name}/schema/local.schema

### deal with the migration tools
%if %{build_migration}
install -d %{buildroot}%{_datadir}/%{name}/migration
install -m 755 MigrationTools-%{migtools_ver}/{*.pl,*.sh,*.txt,*.ph} %{buildroot}%{_datadir}/%{name}/migration
install -m 644 MigrationTools-%{migtools_ver}/README %{SOURCE14} %{buildroot}%{_datadir}/%{name}/migration
install -m 755 %{SOURCE15} %{buildroot}%{_datadir}/%{name}/migration

cp MigrationTools-%{migtools_ver}/README README.migration
cp %{SOURCE14} TOOLS.migration
%endif

mkdir -p %{buildroot}/%{_docdir}/%{name}/{guide,images}
install -m644 doc/guide/admin/*.html doc/guide/admin/*.png %{buildroot}/%{_docdir}/%{name}/guide
install -m644 doc/guide/images/*.gif %{buildroot}/%{_docdir}/%{name}/images

### gencert.sh
install -m 755 %{SOURCE19} %{buildroot}/%{_datadir}/%{name}

### log repository
install -m 700 -d %{buildroot}/var/log/ldap%{ol_major}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -m 644 %{SOURCE20} %{buildroot}%{_sysconfdir}/logrotate.d/ldap%{ol_major}


# get the buildroot out of the man pages
perl -pi -e "s|%{buildroot}||g" %{buildroot}%{_mandir}/*/*.*

#mkdir -p %{buildroot}%{_sysconfdir}/ssl/%{name}

#rename binaries
%if !%{build_system} || %{build_alternatives}
for OLD in %{buildroot}/%{_bindir}/{%{clientbin}}
do
    NEW=`echo ${OLD}%{alternative_major}`
    mv -f $OLD $NEW ||:
    if [ -L $NEW ]
    then ln -sf `readlink $NEW`%{alternative_major} $NEW
    fi
done
for OLD in %{buildroot}/%{_mandir}/man?/{%{clientbin},ldap.conf,ldif}*
do
    if [ -e $OLD ]
    then
        BASE=`perl -e '$_="'${OLD}'"; m,(%buildroot)(.*?)(\.[0-9]),;print "$1$2\n";'`
        EXT=`echo $OLD|sed -e 's,'${BASE}',,g'`
        NEW=`echo ${BASE}%{alternative_major}${EXT}`
        mv $OLD $NEW
    fi
done
%endif
%if !%build_system
for OLD in %{buildroot}/%{_bindir}/{%{serverbin}} %{buildroot}/%{_sbindir}/{%{serversbin}}
do
    NEW=`echo ${OLD}%{ol_major}`
    mv $OLD $NEW -f ||:
    if [ -L $NEW ]
        then ln -sf `readlink $NEW`%{ol_major} $NEW
    fi
done
# And the man pages too:
%if %{db_internal}
for OLD in %{buildroot}/%{_mandir}/man?/{%{serverbin},%{serversbin},slapo}*
%else
for OLD in %{buildroot}/%{_mandir}/man?/{%{serversbin},slapo}*
%endif
do
    if [ -e $OLD ]
    then
        BASE=`perl -e '$_="'${OLD}'"; m,(%buildroot)(.*?)(\.[0-9]),;print "$1$2\n";'`
#        BASE=`perl -e '$name="'${OLD}'"; print "",($name =~ /(.*?)\.[0-9]/), "\n";'`
	EXT=`echo $OLD|sed -e 's,'${BASE}',,g'`
	NEW=`echo ${BASE}%{ol_major}${EXT}`
	mv $OLD $NEW
    fi
done
%endif

#Fix binary names and config paths in scripts/configs
perl -pi -e 's,/%{pkg_name}/,/%{name}/,g;s,(/ldap)/,${1}%{ol_major}/,g;s,(%{_bindir}/slapd_db_\w+),${1}%{ol_major},g;s,(%{_sbindir}/sl(apd|urpd|aptest))\b,${1}%{ol_major},g;s/ldap%{ol_major}-common/ldap-common/g;s,ldap%{ol_major}.pem,ldap.pem,g;s,/usr/lib,%{_libdir},g;s,(/etc/sysconfig/slapd),$1%{ol_major},g' %{buildroot}/{%{_sysconfdir}/%{name}/slapd.conf,%{_unitdir}/slapd%{ol_major}.service,%{_datadir}/%{name}/scripts/*}
perl -pi -e 's/ldap/ldap%{ol_major}/' %{buildroot}/%{_sysconfdir}/logrotate.d/ldap%{ol_major}

 
# install private headers so as to build additional overlays later
install -d -m 755 %{buildroot}%{_includedir}/%{name}/{include,slapd}
install -m 644 include/*.h  %{buildroot}%{_includedir}/%{name}/include
install -d -m 755 %{buildroot}%{_includedir}/%{name}/include/ac
install -m 644 include/ac/*.h  %{buildroot}%{_includedir}/%{name}/include/ac
install -m 644 servers/slapd/*.h  %{buildroot}%{_includedir}/%{name}/slapd
install -d -m 755 %{buildroot}%{_includedir}/%{name}/libraries/liblunicode/ucdata
install -m 644 libraries/liblunicode/ucdata/*.h %{buildroot}%{_includedir}/%{name}/libraries/liblunicode/ucdata

# drop RPATH
chrpath -d %{buildroot}%{_libdir}/%{name}/$(readlink %{buildroot}%{_libdir}/%{name}/smbpwd.so.?)

# Dont drop all  .la files, as OpenLDAP uses them for loading plugins
rm -f %{buildroot}/%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/%{name}/*.a

%pre servers
%_pre_useradd ldap %{_var}/lib/ldap /bin/false
%_pre_groupadd ldap ldap
# allowing slapd to read hosts.allow and hosts.deny
%{_bindir}/gpasswd -a ldap adm 1>&2 > /dev/null || :
if [ "$1" -ne '1' ]
then
if [ -e /etc/sysconfig/ldap%{ol_major} ]
then mv /etc/sysconfig/ldap%{ol_major} /etc/sysconfig/slapd%{ol_major}
fi
LDAPUSER=ldap
LDAPGROUP=ldap
[ -e "/etc/sysconfig/slapd%{ol_major}" ] && . "/etc/sysconfig/slapd%{ol_major}"
if [ -z "$SLAPDCONF" ]
then
    if [ -e "/etc/%{name}/slapd.d/cn=config.ldif" ]
    then SLAPDCONF=/etc/%{name}/slapd.d
    else SLAPDCONF=/etc/%{name}/slapd.conf
    fi
fi
echo "Using $SLAPDCONF as configuration for %pre servers"
SLAPD_STATUS=`systemctl is-active slapd%{ol_major}.service > %_service_status_file;echo $[1-$?]`
if [[ $SLAPD_STATUS -eq 1 ]]
then
    echo "Stopping slapd%{ol_major}.service via systemd and recovering via ldap-config"
    systemctl stop slapd%{ol_major}.service
fi
/usr/share/openldap/scripts/ldap-config recover
if [ -e "$SLAPDCONF/cn=config.ldif" ]
then 
    echo "Creating a config export from $SLAPDCONF as /etc/%{name}/slapd-config-rpm-upgrade.ldif"
    slapcat%{ol_major} -n0 -l /etc/%{name}/slapd-config-rpm-upgrade.ldif
fi

#decide whether we need to migrate at all:
MIGRATE=`%{_sbindir}/slapd%{ol_major} -VV 2>&1|while read a b c d e;do case $d in (2.4.*) echo nomigrate;;(2.*) echo migrate;;esac;done`

if [ "$1" -ne 1 -a -e "$SLAPDCONF" -a "$MIGRATE" != "nomigrate" ]
then 
#`awk '/^[:space:]*directory[:space:]*\w*/ {print $2}' /etc/%{name}/slapd.conf`
dbs=`awk 'BEGIN {OFS=":"} /[[:space:]]*^database[[:space:]]*\w*/ {db=$2;suf="";dir=""}; /^[[:space:]]*suffix[[:space:]]*\w*/ {suf=$2;if((db=="bdb"||db=="ldbm"||db=="hdb")&&(suf!=""&&dir!="")) print dir,suf};/^[[:space:]]*directory[[:space:]]*\w*/ {dir=$2; if((db=="bdb"||db=="ldbm"||db="hdb")&&(suf!=""&&dir!="")) print dir,suf};' "$SLAPDCONF" $(awk  '/^[[:blank:]]*include[[:blank:]]*/ {print $2}' "$SLAPDCONF")|sed -e 's/\"//g'`
for db in $dbs
do
	dbdir=${db/:*/}
	dbsuffix=${db/*:/}
	[ -e /etc/sysconfig/slapd%{ol_major} ] && . /etc/sysconfig/slapd%{ol_major}
# data migration between incompatible versions
# openldap >= 2.2.x have slapcat as a link to slapd, older releases do not
	if [ "${AUTOMIGRATE:-yes}" == "yes" -a -f %{_sbindir}/slapcat ]
	then
		ldiffile="rpm-migrate-to-%{ol_ver_major}.ldif"
		# dont do backups more than onc
		if [ ! -e "${dbdir}/${ldiffile}-imported" -a ! -e "${dbdir}/${ldiffile}-import-failed" ];then
		echo "Migrating pre-OpenLDAP-%{ol_ver_major} data"
		echo "Making a backup of $dbsuffix to ldif file ${dbdir}/$ldiffile"
		# For some reason, slapcat works in the shell when slapd is
		# running but not via rpm ...
		slapcat%{ol_major} -b "$dbsuffix" -l ${dbdir}/${ldiffile} ||:
		fi
	fi
done
fi
fi

%post servers
%_tmpfilescreate %{pkg_name}%{ol_major}
SLAPD_STATUS=`systemctl -q is-active slapd%{ol_major}.service;echo $[1-$?]`
[ $SLAPD_STATUS -eq 1 ] && systemctl stop slapd%{ol_major}.service
# bgmilne: part 2 of gdbm->dbb conversion for data created with 
# original package for 9.1:
dbnum=1
LDAPUSER=ldap
LDAPGROUP=ldap
[ -e "/etc/sysconfig/slapd%{ol_major}" ] && . "/etc/sysconfig/slapd%{ol_major}"
SLAPDCONF=${SLAPDCONF:-/etc/%{name}/slapd.conf}
if [ -e "$SLAPDCONF" ] 
then
dbs=`awk 'BEGIN {OFS=":"} /[[:space:]]*^database[[:space:]]*\w*/ {db=$2;suf="";dir=""}; /^[[:space:]]*suffix[[:space:]]*\w*/ {suf=$2;if((db=="bdb"||db=="ldbm")&&(suf!=""&&dir!="")) print dir,suf};/^[[:space:]]*directory[[:space:]]*\w*/ {dir=$2; if((db=="bdb"||db=="ldbm")&&(suf!=""&&dir!="")) print dir,suf};' "$SLAPDCONF" $(awk  '/^[[:blank:]]*include[[:blank:]]*/ {print $2}' "$SLAPDCONF")|sed -e 's/\"//g'`
for db in $dbs
do	
	dbdir=${db/:*/}
	dbsuffix=${db/*:/}
	ldiffile="rpm-migrate-to-%{ol_ver_major}.ldif"
	if [ -e "${dbdir}/${ldiffile}" ]
	then
		echo -e "\n\nImporting $dbsuffix"
		if [ -e ${dbdir}/ldap-rpm-backup ]
		then 
			echo "Warning: Old ldap backup data in ${dbdir}/ldap-rpm-backup"
			echo "These files will be removed"
			rm -f ${dbdir}/ldap-rpm-backup/*
		fi
	
		echo "Moving the database files fom ${dbdir} to ${dbdir}/ldap-rpm-backup"
		mkdir -p ${dbdir}/ldap-rpm-backup
		mv -f ${dbdir}/{*.bdb,*.gdbm,*.dbb,log.*,__db*} ${dbdir}/ldap-rpm-backup 2>/dev/null
		echo "Importing $dbsuffix from ${dbdir}/${ldiffile}"
		if slapadd%{ol_major} -q -cv -b "$dbsuffix" -l ${dbdir}/${ldiffile} > \
		${dbdir}/rpm-ldif-import.log 2>&1
		then
			mv -f ${dbdir}/${ldiffile} ${dbdir}/${ldiffile}-imported
			echo "Import complete, see log ${dbdir}/rpm-ldif-import.log"
			echo "If any entries were not migrated, see ${dbdir}/${ldiffile}-imported"
		else
			mv -f ${dbdir}/${ldiffile} ${dbdir}/${ldiffile}-import-failed
			echo "Import failed on ${dbdir}/${ldifffile}, see ${dbdir}/rpm-ldif-import.log"
			echo "An ldif dump of $dbsuffix has been saved as ${dbdir}/${ldiffile}-import-failed"
			echo -e "\nYou can import it manually by running (as root):"
			echo "# systemctl stop slapd%{ol_major}"
			echo "# slapadd%{ol_major} -c -l ${dbdir}/${ldiffile}-import-failed"
			echo "# chown $LDAPUSER:$LDAPGROUP ${dbdir}/*"
			echo "# systemctl start slapd%{ol_major}"
		fi
	fi

	chown ${LDAPUSER}:${LDAPGROUP} -R ${dbdir}
	# openldap-2.0.x->2.1.x on ldbm/dbb backend seems to need reindex regardless:
	#slapindex -n $dbnum
	#dbnum=$[dbnum+1]
done
fi

# Setup log facility for OpenLDAP on new install
%_post_syslogadd /var/log/ldap%{ol_major}/ldap.log local4
perl -pi -e "s|^.*SLAPDSYSLOGLOCALUSER.*|SLAPDSYSLOGLOCALUSER=\"local4\"|" \
    %{_sysconfdir}/sysconfig/slapd%{ol_major}

# Handle switch from %{_sysconfdir}/ssl/%{name}/ldap.pem to %{_sysconfdir}/pki/tls/private/ldap.pem
if [ -e %{_sysconfdir}/ssl/%{name}/ldap.pem -a ! -e %{_sysconfdir}/pki/tls/private/ldap.pem ]
then
  mv %{_sysconfdir}/ssl/%{name}/ldap.pem %{_sysconfdir}/pki/tls/private/ldap.pem
  ln -s %{_sysconfdir}/pki/tls/private/ldap.pem %{_sysconfdir}/ssl/%{name}/ldap.pem
fi
# generate the ldap.pem cert here instead of the initscript
%if %{?_create_ssl_certificate:1}%{!?_create_ssl_certificate:0}
%_create_ssl_certificate -g ldap ldap
%else
if [ ! -e %{_sysconfdir}/pki/tls/private/ldap.pem ]
then
  if [ -x %{_datadir}/%{name}/gencert.sh ] ; then
    echo "Generating self-signed certificate..."
    pushd %{_sysconfdir}/pki/tls/private > /dev/null
    yes ""|%{_datadir}/%{name}/gencert.sh >/dev/null 2>&1
    chmod 640 ldap.pem
    chown root:ldap ldap.pem
    popd > /dev/null
  fi
  echo "To generate a self-signed certificate, you can use the utility"
  echo "%{_datadir}/%{name}/gencert.sh..."
fi
%endif

pushd %{_sysconfdir}/%{name}/ > /dev/null
for i in slapd.conf slapd.access.conf ; do
	if [ -f $i ]; then
		chmod 0640 $i
		chown root:ldap $i
	fi
done
popd > /dev/null

%_post_service slapd%{ol_major}
PRE_STATUS=$(head -n1 %_service_status_file)
if [[ $SLAPD_STATUS -eq 1 || "$PRE_STATUS" == "active" ]] 
then
    echo "Starting slapd%{ol_major} after upgrade"
    systemctl -q start slapd%{ol_major}
fi
rm -f %_service_status_file

# nscd reset
systemctl -q try-restart nscd

%preun servers
%_preun_service slapd%{ol_major}


%postun servers
%_preun_syslogdel
%_postun_userdel ldap
%_postun_groupdel ldap


%files
%config(noreplace) %{_sysconfdir}/%{name}/ldapserver
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/%{name}/ldap.conf
%{_mandir}/man5/ldap.conf%{ol_major}.5*
%{_mandir}/man5/ldif%{ol_major}.5*
%doc README.mageia


%files doc
%doc ANNOUNCEMENT CHANGES COPYRIGHT LICENSE README 
%if %{build_migration}
%doc README.migration TOOLS.migration
%endif
%doc doc/rfc doc/drafts
%doc %{_docdir}/%{name}/guide
%doc %{_docdir}/%{name}/images

%if %{build_migration}
%files migration
%{_datadir}/%{name}/migration
%endif


%files servers
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/schema
%attr(640,root,ldap) %config(noreplace) %{_sysconfdir}/%{name}/slapd.conf
%attr(640,root,ldap) %config(noreplace) %{_sysconfdir}/%{name}/slapd.ldif
%dir %attr(750,ldap,ldap) %{_sysconfdir}/%{name}/slapd.d
%attr(640,root,ldap) %config %{_sysconfdir}/%{name}/slapd.access.conf

%config(noreplace) %{_sysconfdir}/%{name}/schema/*.schema
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/schema
%{_datadir}/%{name}/schema/*.schema
%{_datadir}/%{name}/schema/*.ldif
%{_datadir}/%{name}/schema/README
%{_datadir}/%{name}/scripts
%{_sysconfdir}/cron.hourly/ldap-hot-db-backup%{ol_major}
%{_sysconfdir}/cron.daily/ldap-hot-db-backup%{ol_major}
%{_sysconfdir}/cron.weekly/ldap-hot-db-backup%{ol_major}
%{_sysconfdir}/cron.monthly/ldap-hot-db-backup%{ol_major}
%{_sysconfdir}/cron.yearly/ldap-hot-db-backup%{ol_major}

%config(noreplace) %{_sysconfdir}/sysconfig/slapd%{ol_major}
%config(noreplace) %{_unitdir}/slapd%{ol_major}.service
%attr(750,ldap,ldap) %dir %{_var}/lib/ldap%{ol_major}
%{_tmpfilesdir}/%{pkg_name}%{ol_major}.conf
%{_datadir}/%{name}/gencert.sh
%{_sbindir}/*
%{_libdir}/libslapi*.so.*

%dir %{_libdir}/%{name}
%if %{build_modules} && !%{build_modpacks}
%{_libdir}/%{name}/*.la
%{_libdir}/%{name}/*.so*
%endif
%if !%{build_modp_mdb}
%{_libdir}/%{name}/back_mdb*
%endif
%if !%{build_modp_mdb} && %{lmdb_internal}
%{_bindir}/mdb_*
%{_mandir}/man1/mdb_*
%endif
%if %{build_bdb} && !%{build_modp_bdb}
%config(noreplace) %{_var}/lib/ldap%{ol_major}/DB_CONFIG
%{_var}/lib/ldap%{ol_major}/DB_CONFIG.example
%attr(640,root,ldap) %{_sysconfdir}/%{name}/DB_CONFIG.example
%{_libdir}/%{name}/back_bdb*
%{_libdir}/%{name}/back_hdb*
%if %{db_internal}
#internal version of db
%{_libdir}/libslapd%{ol_suffix}_db*
%attr(755,root,root)%{_bindir}/slapd%{ol_major}_db*
%exclude %{_prefix}/docs
%exclude %{_includedir}/db*.h
%endif #db_internal
%endif #!build_modp_bdb
%if %{build_modules} && %{build_modpacks}
%{_libdir}/%{name}/back_monitor*
%{_libdir}/%{name}/back_ldap*
%{_libdir}/%{name}/back_meta*
%{_libdir}/%{name}/back_passwd*
%{_libdir}/%{name}/back_dns*
%{_libdir}/%{name}/back_null*
%{_libdir}/%{name}/back_relay*
%{_libdir}/%{name}/back_sock*
%if %{back_shell}
%{_libdir}/%{name}/back_shell*
%endif
%{_libdir}/%{name}/accesslog*
%{_libdir}/%{name}/addpartial*
%{_libdir}/%{name}/allop*
%{_libdir}/%{name}/allowed*
%{_libdir}/%{name}/auditlog*
%{_libdir}/%{name}/autogroup*
%{_libdir}/%{name}/cloak*
%{_libdir}/%{name}/collect*
%{_libdir}/%{name}/constraint*
%{_libdir}/%{name}/dds*
%{_libdir}/%{name}/denyop*
%{_libdir}/%{name}/deref*
%{_libdir}/%{name}/dupent*
%{_libdir}/%{name}/dyngroup*
%{_libdir}/%{name}/dynlist*
%{_libdir}/%{name}/kerberos*
%{_libdir}/%{name}/lastbind*
%{_libdir}/%{name}/lastmod*
%{_libdir}/%{name}/memberof*
%{_libdir}/%{name}/netscape*
%{_libdir}/%{name}/noopsrch*
%if %{build_nssov}
%{_libdir}/%{name}/nssov*
%endif
%{_libdir}/%{name}/pcache*
%{_libdir}/%{name}/ppolicy*
%{_libdir}/%{name}/pw-apr1*
%{_libdir}/%{name}/pw-kerberos*
%{_libdir}/%{name}/pw-netscape*
%{_libdir}/%{name}/pw-sha2*
%{_libdir}/%{name}/pw-pbkdf2*
%{_libdir}/%{name}/refint*
%{_libdir}/%{name}/retcode*
%{_libdir}/%{name}/rwm*
%{_libdir}/%{name}/seqmod*
%{_libdir}/%{name}/smbpwd*
%{_libdir}/%{name}/sssvlv*
%{_libdir}/%{name}/syncprov*
%{_libdir}/%{name}/trace*
%{_libdir}/%{name}/translucent*
%{_libdir}/%{name}/unique*
%{_libdir}/%{name}/valsort*
%endif

%{_mandir}/man5/slap*.5*
%{_mandir}/man8/*

%attr(750,ldap,ldap) %dir /var/log/ldap%{ol_major}
%config(noreplace) %{_sysconfdir}/logrotate.d/ldap%{ol_major}

%doc contrib/slapd-modules/acl/README.*
%doc contrib/slapd-modules/addpartial/README.addpartial
%doc contrib/slapd-modules/allop/README.allop
%doc contrib/slapd-modules/allowed/README.allowed
%doc contrib/slapd-modules/autogroup/README.autogroup
#doc contrib/slapd-modules/dsaschema/README.dsaschema
%doc contrib/slapd-modules/kinit/README.kinit
%{_libdir}/%{name}/kinit*
%doc contrib/slapd-modules/passwd/README.passwd
%doc contrib/slapd-modules/passwd/sha2/README.sha2
%doc contrib/slapd-modules/passwd/pbkdf2/README.pbkdf2
%if %{build_smbk5pwd}
%doc contrib/slapd-modules/smbk5pwd/README.smbk5pwd
%endif
%if %{build_nssov}
%doc contrib/slapd-modules/nssov/README.nssov
%endif

%files servers-devel
%{_includedir}/slapi-plugin.h
%{_libdir}/libslapi.so

%files clients
%{_bindir}/ldap*
%{_mandir}/man1/ldap*

%files -n %{libname}
%exclude %{_libdir}/libslapi*.so.*
%{_libdir}/lib*.so.*

%files -n %{libname}-devel
%{_libdir}/libl*.so
%{_includedir}/l*.h
%{_includedir}/openldap.h
%{_includedir}/%{name}
%{_mandir}/man3/*

%files -n %{libname}-static-devel
%{_libdir}/lib*.a

%if %{build_modpacks}
%if 0
%files back_dnssrv
%{_libdir}/%{name}/back_dnssrv.la
%{_libdir}/%{name}/back_dnssrv*.so.*
%{_libdir}/%{name}/back_dnssrv*.so

%files back_ldap
%{_libdir}/%{name}/back_ldap.la
%{_libdir}/%{name}/back_ldap*.so.*
%{_libdir}/%{name}/back_ldap*.so

%files back_passwd
%{_libdir}/%{name}/back_passwd.la
%{_libdir}/%{name}/back_passwd*.so.*
%{_libdir}/%{name}/back_passwd*.so
%endif #0

%if %{build_modp_sql}
%files back_sql
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/back_sql.la
%{_libdir}/%{name}/back_sql*.so.*
%{_libdir}/%{name}/back_sql*.so
%endif

%if %{build_modp_bdb}
%files back_bdb
%config(noreplace) %{_var}/lib/ldap%{ol_major}/DB_CONFIG
%{_var}/lib/ldap%{ol_major}/DB_CONFIG.example
%attr(640,root,ldap) %{_sysconfdir}/%{name}/DB_CONFIG.example
%{_libdir}/%{name}/back_bdb*
%{_libdir}/%{name}/back_hdb*
%if %{db_internal}
#internal version of db
%{_libdir}/libslapd%{ol_suffix}_db*
%attr(755,root,root)%{_bindir}/slapd%{ol_major}_db*
%exclude %{_prefix}/docs
%exclude %{_includedir}/db*.h
%endif #db_internal
%endif #build_modp_bdb

%if %{build_modp_mdb}
%files back_mdb
%{_libdir}/%{name}/back_mdb*
%endif
%if %{build_modp_mdb} && %{lmdb_internal}
%{_bindir}/mdb_*
%{_mandir}/man1/mdb_*
%endif

%endif #build_modpacks

%files tests
%{_datadir}/%{name}/tests

%files testprogs
%{_bindir}/slapd-*
%{_bindir}/ldif-filter%{ol_major}
#
# Todo:
# - add cron-job to remove transaction logs (bdb)


%changelog
* Wed May 10 2023 neoclust <neoclust> 2.4.59-6.mga9
+ Revision: 1956461
- Rebuild against latest lmdb

* Sun Sep 11 2022 buchan <buchan> 2.4.59-5.mga9
+ Revision: 1887313
- Build as non-system package for Mageia 9 and up
+ wally <wally>
- drop Mandrake/Mandriva leftovers from .spec

* Sat May 21 2022 buchan <buchan> 2.4.59-4.mga9
+ Revision: 1859703
- Add patch for CVE-2022-29155 (mga#30439)

* Tue Mar 29 2022 umeabot <umeabot> 2.4.59-3.mga9
+ Revision: 1833089
- Mageia 9 Mass Rebuild

* Sat Oct 02 2021 wally <wally> 2.4.59-2.mga9
+ Revision: 1747379
- rebuild for openssl 3.0.0
- fix RPATH issue
- don't remove .la files

* Wed Jun 09 2021 buchan <buchan> 2.4.59-1.mga9
+ Revision: 1730244
- Update to 2.4.59

* Thu Mar 18 2021 buchan <buchan> 2.4.58-1.mga9
+ Revision: 1704466
- Update to 2.4.58

* Sat Feb 27 2021 neoclust <neoclust> 2.4.57-2.mga9
+ Revision: 1692456
- Add P1000: Fixes CVE-2021-27212 (mga#28300)

* Tue Jan 19 2021 luigiwalser <luigiwalser> 2.4.57-1.mga8
+ Revision: 1672512
- 2.4.57

* Fri Jan 01 2021 luigiwalser <luigiwalser> 2.4.56-2.mga8
+ Revision: 1667810
- build without tcp_wrappers due to conflict libnsl/libtirpc/heimdal

* Wed Nov 11 2020 luigiwalser <luigiwalser> 2.4.56-1.mga8
+ Revision: 1644444
- 2.4.56

* Mon Nov 02 2020 luigiwalser <luigiwalser> 2.4.55-2.mga8
+ Revision: 1641703
- rebuild for lmdb

* Tue Oct 27 2020 luigiwalser <luigiwalser> 2.4.55-1.mga8
+ Revision: 1639858
- 2.4.55

* Tue Oct 13 2020 luigiwalser <luigiwalser> 2.4.54-1.mga8
+ Revision: 1634826
- 2.4.54

* Tue Sep 08 2020 luigiwalser <luigiwalser> 2.4.53-1.mga8
+ Revision: 1623406
- 2.4.53

* Wed Sep 02 2020 luigiwalser <luigiwalser> 2.4.52-2.mga8
+ Revision: 1621131
- rebuild for lmdb

* Sat Aug 29 2020 luigiwalser <luigiwalser> 2.4.52-1.mga8
+ Revision: 1619622
- 2.4.52

* Wed Aug 12 2020 luigiwalser <luigiwalser> 2.4.51-1.mga8
+ Revision: 1613622
- 2.4.51

* Sun Jul 19 2020 martinw <martinw> 2.4.50-4.mga8
+ Revision: 1607237
- rebuild for new liblmdb0
+ ovitters <ovitters>
- remove config.{guess,sub} hack due to changes in rpm-mageia-setup

* Thu Jun 11 2020 ovitters <ovitters> 2.4.50-3.mga8
+ Revision: 1592448
- use new location for config.{guess,sub}
- fix pidfile path (mga#26768)

* Sat May 02 2020 buchan <buchan> 2.4.50-2.mga8
+ Revision: 1577769
- Drop nops overlay mga#24076

* Wed Apr 29 2020 buchan <buchan> 2.4.50-1.mga8
+ Revision: 1573338
- Update to 2.4.50

* Sat Apr 18 2020 buchan <buchan> 2.4.49-1.mga8
+ Revision: 1569008
- Update to 2.4.49
+ danf <danf>
- Switch URLs from http: to https:
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x
- replace deprecated %%makeinstall_std

* Thu Jul 25 2019 buchan <buchan> 2.4.48-1.mga8
+ Revision: 1424172
- Update to 2.4.48

* Sun May 12 2019 buchan <buchan> 2.4.47-3.mga7
+ Revision: 1397399
- Fix restarts during upgrades (#16801)

* Tue Jan 15 2019 luigiwalser <luigiwalser> 2.4.47-2.mga7
+ Revision: 1357007
- rebuild for cyrus-sasl

* Thu Dec 20 2018 buchan <buchan> 2.4.47-1.mga7
+ Revision: 1343873
- New version 2.4.47
- Since we dont run tests by default, add some hints on
  how to run them after installing.

* Fri Oct 05 2018 daviddavid <daviddavid> 2.4.46-2.mga7
+ Revision: 1317789
- Mageia 7 Mass Rebuild

* Thu Apr 05 2018 buchan <buchan> 2.4.46-1.mga7
+ Revision: 1215559
- New version 2.4.46
+ luigiwalser <luigiwalser>
- remove sysv init script due to CVE-2017-14159

* Wed Aug 02 2017 guillomovitch <guillomovitch> 2.4.45-3.mga7
+ Revision: 1134226
- rebuild for latest openssl

* Sun Jun 04 2017 neoclust <neoclust> 2.4.45-2.mga6
+ Revision: 1106718
- Fix typo in requires
+ buchan <buchan>
- 2.4.45
- Remove upstream patches
- Add versioned requirement on liblmdb in -back_mdb
- Make mdb the default backend
- Fix all incorrect occurences of /etc/sysconfig/ldap
- Update documentation patches, and always build docs
- Fix conditional tests (but disabled by default)

* Thu Jun 01 2017 neoclust <neoclust> 2.4.44-5.mga6
+ Revision: 1105744
- Add P100 - Fixes CVE-2017-9287 (mga#21003)

* Fri Nov 25 2016 neoclust <neoclust> 2.4.44-4.mga6
+ Revision: 1070103
- Do not require openldap-back_bdb for the moment

* Fri Nov 25 2016 neoclust <neoclust> 2.4.44-3.mga6
+ Revision: 1070089
- Do not use deprecated bdb backend by default

* Thu Mar 03 2016 umeabot <umeabot> 2.4.44-2.mga6
+ Revision: 983852
- Rebuild for openssl

* Tue Feb 09 2016 luigiwalser <luigiwalser> 2.4.44-1.mga6
+ Revision: 951827
- 2.4.44
- add patch from opensuse to enforce min DH size of 1024 (CVE-2015-4000, LOGJAM)

* Fri Jan 08 2016 buchan <buchan> 2.4.43-3.mga6
+ Revision: 920605
- openldap-servers no longer requires back_bdb (added to allow transition from built-in
  back_bdb support in Mageia 3 to module in Mageia 4)
  openldap-servers now suggests back_mdb, to become the default in future
- Build the pbkdf2 password module in contrib (since 2.4.41)
- Clean up configure warnings, including not bulding back-shell by default
- Allow either building the internal lmdb (--with lmdbinternal), or building
  against system lmdbi shared library (default on Mageia > 5)
- Update bundled db to 5.3.28 and build it on anything less than 5.3
  Allow building without Berkeley DB (--without bdb --without hdb)
- Make ldap-config exit non-zero if config checking failed so systemd fails it
+ luigiwalser <luigiwalser>
- 2.4.43

* Fri Sep 18 2015 neoclust <neoclust> 2.4.42-1.mga6
+ Revision: 880334
- New version 2.4.42
- use system lmdb

* Fri Sep 11 2015 luigiwalser <luigiwalser> 2.4.40-6.mga6
+ Revision: 876932
- add upstream patch to fix DoS due to assertion left in code (its#8240)

* Fri Aug 21 2015 tmb <tmb> 2.4.40-5.mga6
+ Revision: 867615
- rebuild for new gcc
+ luigiwalser <luigiwalser>
- support SLAPDSYSLOGLEVEL in service file (mga#13470)
- remove unused MAXFILES variable from sysconfig file
- add upstream patch to test suite for CVE-2015-1546

* Sun Feb 08 2015 luigiwalser <luigiwalser> 2.4.40-3.mga5
+ Revision: 814066
- add upstream patches to fix CVE-2015-1545 and CVE-2015-1546

* Fri Oct 10 2014 colin <colin> 2.4.40-2.mga5
+ Revision: 737858
- Fix ldap-check vs ldap-config typo

* Sat Oct 04 2014 luigiwalser <luigiwalser> 2.4.40-1.mga5
+ Revision: 736709
- 2.4.40
- remove upstreamed patches 9 and 14

* Sun Feb 16 2014 luigiwalser <luigiwalser> 2.4.39-1.mga5
+ Revision: 592557
- 2.4.39
- remove upstreamed patches

* Mon Feb 10 2014 luigiwalser <luigiwalser> 2.4.38-2.mga5
+ Revision: 587838
- add patch from redhat to fix CVE-2013-4449

* Wed Jan 01 2014 buchan <buchan> 2.4.38-1.mga4
+ Revision: 563729
- Fix build on i586
- New version 2.4.38
- Update some patches for 2.4.35 and later
- Fix installation of nssov
- Include post-2.4.38 patches for ITSs: 7749, 7750, 7756, 7757
- In order to allow removal of back_bdb in future without breaking configs:
  - Build back_bdb and back_hdb as modules and ship in openldap-back_bdb package
  - Add triggerpostun in openldap-back_bdb on openldap-servers to modify the
    configuration (either slapd.conf or slapd.d) to ensure the modules
    are loaded.
  - Until after mga4 release, openldap-servers will require openldap-back_bdb
    since many users will require them
- Split back_sql out as well to reduce dependencies
- Ship mdb backend in a separate package, with mdb utils
- Add systemd support (but still provide init script for legacy systems)
- Rename service from 'ldap' to 'slapd'

* Sat Aug 31 2013 wally <wally> 2.4.33-10.mga4
+ Revision: 473694
- fix sasl libname again

* Thu Aug 29 2013 fwang <fwang> 2.4.33-9.mga4
+ Revision: 472766
- fix sasl libname

* Tue Aug 27 2013 luigiwalser <luigiwalser> 2.4.33-8.mga4
+ Revision: 472082
- rebuild for cyrus-sasl

* Sat May 11 2013 guillomovitch <guillomovitch> 2.4.33-7.mga3
+ Revision: 413001
- use systemctl in logrotate, instead of sysinit script

* Wed May 08 2013 luigiwalser <luigiwalser> 2.4.33-6.mga3
+ Revision: 412661
- fix upgrade issue during installer when /var/lock/subsys does not exist

* Wed Mar 27 2013 mitya <mitya> 2.4.33-5.mga3
+ Revision: 405431
- Build with SLAPI support

* Sun Mar 24 2013 colin <colin> 2.4.33-4.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)
- Ensure tmpfiles support is optional for better portability

* Thu Jan 17 2013 colin <colin> 2.4.33-2.mga3
+ Revision: 389011
- Switch to tmpfiles for /run dir creation

* Mon Oct 15 2012 buchan <buchan> 2.4.33-1.mga3
+ Revision: 306387
- Comply with new group policy (doc package moves to Documentation group)
- New version 2.4.33
- Build an internal copy of db-5.1.29 on any distro that doesnt have it or newer
- Fix building with db_internal on current distros

* Fri Aug 17 2012 buchan <buchan> 2.4.32-1.mga3
+ Revision: 281766
- New version 2.4.32

* Tue Jul 31 2012 fwang <fwang> 2.4.31-5.mga3
+ Revision: 276317
- rebuild for db-5.3

* Wed Jul 25 2012 fwang <fwang> 2.4.31-4.mga3
+ Revision: 274166
- rebuild for new db5.2

* Fri Jul 20 2012 fwang <fwang> 2.4.31-3.mga3
+ Revision: 272764
- we are using db 5.2 now

* Fri Jul 20 2012 fwang <fwang> 2.4.31-2.mga3
+ Revision: 272746
- rebuild for new db 51
+ buchan <buchan>
- Fix awk space pattern in pre/post scripts (back-config case should be considered)

* Thu Jun 21 2012 buchan <buchan> 2.4.31-1.mga3
+ Revision: 262497
- New version 2.4.31
- Merge some changes from/for Mandriva

* Sun Apr 29 2012 sander85 <sander85> 2.4.29-2.mga2
+ Revision: 234266
- try to fix build
+ dlucio <dlucio>
- fix #5605

* Thu Feb 16 2012 buchan <buchan> 2.4.29-1.mga2
+ Revision: 209792
- New version 2.4.29
- rediff patches (contrib make files, test001 adding slapcat check)
- Fix packaged test suite (by fixing olcModulePath in all tests, shipping ldif-filter)
- Fix default config for split cert/key as generated by rpm-helper (bug #1978)
-Update gencert to have similar behaviour, in case rpm-helper is not available

* Tue Dec 20 2011 buchan <buchan> 2.4.28-1.mga2
+ Revision: 184844
- Rest of BR on db5-devel only on Mageia > 1
- On Mageia > 1 only, BR db5-devel
- 2.4.28
- Fix errors from 'service ldap recover' etc. due to versioned binaries in db51-utils
- Revert dropping all libtool archive files, OpenLDAP uses them to load plugins.
  Instead, only drop the shared library libtool archive files.
- Revert wrong db5 br that will break builds on other distros
- Update contrib makefile patch for apr1

* Thu Dec 08 2011 fwang <fwang> 2.4.26-3.mga2
+ Revision: 178879
- rebuild for new odbc

* Tue Nov 22 2011 fwang <fwang> 2.4.26-2.mga2
+ Revision: 170841
- br db 5
- drop .la files
- fix req on db-utils
- br db5
- rebuild against db4.8
+ buchan <buchan>
- Revert mdv r675900, 'make openldap less restrictibe requiring db', it can break upgrades
- Add a description of why we have an exact version dependency
- Sync with Mdv 2.4.26-1
- Hopefully fix db dependencies correctly for all mageia releases

* Wed Apr 20 2011 pterjan <pterjan> 2.4.25-1.mga1
+ Revision: 88923
- Update to 2.4.25
- Sync with mdv

* Mon Jan 17 2011 pterjan <pterjan> 2.4.23-4.mga1
+ Revision: 21712
- Define a fake mdkversion
+ spuhler <spuhler>
- imported package openldap

